=== debian/changelog ===
ismrmrd (1.15.0-2) unstable; urgency=medium

  * Team upload.
  * Revert Build-Depends: architecture-is-64-bit

 -- Andreas Tille <tille@debian.org>  Sun, 22 Feb 2026 11:12:02 +0100

ismrmrd (1.15.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
    Closes: #1128127
  * Standards-Version: 4.7.3
  * Build-Depends: architecture-is-64-bit
    Closes: #863168
  * Drop use of autotools-dev debhelper.
  * Bump SONAME due to new upstream version

 -- Andreas Tille <tille@debian.org>  Sat, 21 Feb 2026 18:24:53 +0100

ismrmrd (1.14.3-3) unstable; urgency=medium

  * Team upload.
  * d/rules: do not run tests on no-arch-any builds.
    Necessary binaries are not available in such conditions.

 -- Étienne Mollier <emollier@debian.org>  Fri, 28 Nov 2025 19:36:07 +0100

ismrmrd (1.14.3-2) unstable; urgency=medium

  * Team upload.
  * struct-padding.patch: new: fix ftbfs on 32-bit. (Closes: #1119868)
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/copyright: drop unused license terms.

 -- Étienne Mollier <emollier@debian.org>  Fri, 28 Nov 2025 18:52:17 +0100
