=== debian/control ===
Source: ismrmrd
Standards-Version: 4.7.3
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Ghislain Antony Vaillant <ghisvail@gmail.com>,
Section: science
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 d-shlibs,
 libboost-filesystem-dev,
 libboost-program-options-dev,
 libboost-random-dev,
 libboost-test-dev,
 libfftw3-dev,
 libhdf5-dev,
 libpugixml-dev,
Build-Depends-Indep:
 doxygen,
Vcs-Browser: https://salsa.debian.org/med-team/ismrmrd
Vcs-Git: https://salsa.debian.org/med-team/ismrmrd.git
Homepage: https://ismrmrd.github.io/

Package: libismrmrd1.15
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libismrmrd1.7,
 libismrmrd1.8,
Replaces:
 libismrmrd1.7,
 libismrmrd1.8,
Description: ISMRM Raw Data format (ISMRMRD)
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the shared library.

Package: libismrmrd-dev
Architecture: any
Section: libdevel
Depends:
 ${misc:Depends},
 libhdf5-dev,
 libpugixml-dev,
 libismrmrd1.15 (= ${binary:Version}),
Suggests:
 libismrmrd-doc,
Description: development files for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the development files.

Package: libismrmrd-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
Description: documentation for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the documentation.

Package: ismrmrd-tools
Architecture: any
Multi-Arch: foreign
Section: utils
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ismrmrd-schema,
Description: command-line tools for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the command-line tools.

Package: ismrmrd-schema
Architecture: all
Multi-Arch: foreign
Section: misc
Depends:
 ${misc:Depends},
Description: schema for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the XML schema.
