=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export LC_ALL=en_US.UTF-8

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SYSTEM_PUGIXML=ON -DCMAKE_POLICY_VERSION_MINIMUM=3.5

override_dh_auto_build-indep:
	dh_auto_build -- apidoc

override_dh_auto_test-indep:
	@echo 'I: There are no tests to run for arch-all builds.'

override_dh_install-arch:
	find debian/tmp -name ismrmrd.xsd -delete
	dh_install -a
	d-shlibmove --commit \
		 --multiarch \
		 --devunversioned \
		 --exclude-la \
		 --movedev debian/tmp/usr/lib/*/cmake usr/lib/$(DEB_HOST_MULTIARCH) \
		 --movedev debian/tmp/usr/include usr \
		 debian/tmp/usr/lib/*/*.so
	find debian -name "lib*.la" -delete

override_dh_auto_install-indep:
	echo "No need to do install for architecture indep packages"

override_dh_auto_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep

override_dh_compress:
	dh_compress --exclude=examples

override_dh_missing-arch:
	find debian/tmp -type f \( -name '*.m' -o -name 'ismrmrd_c_example' \) -delete
	dh_missing -a
